unit chanflagstuff;

interface
// this unit contains everything needed to convert a numeric chanflags value to
// a text one it was seperated out to aviod l2c depending on huge mounts of
// stuff
type
  tchanflagtable=record
    c:char;               {mode char}
    flag:integer;         {mode flag}
(*   disabled:boolean;     {disabled by options (cant be seen/used by clients)}
    auto:boolean;         {no special precautions needed when reggedchanging the mode, by a client}*)
    num:^integer;
  end;
  achanflagtable = array[0..0] of tchanflagtable;

const
  channelsfile='channel.channels.ini';

  // note: the lower numered ones of theese are the same as lightweight to
  // simplyfy converting it's accounts files (l stores channel flags numerically)
  // $1 is not used as it is used for chanflag_joined in lightweight something
  // this channel service does not store (it always sits on channels no matter
  // when they were last used)
  // ones marked with //* have at least some actual code associated
  chanflag_suspended      =   $2; //*
  chanflag_bitch          =   $4; //*
  chanflag_protectops     =   $8; //*
  chanflag_forcetopic     =  $10; //*
  chanflag_welcomemessage =  $20; //*
  chanflag_forceinvite    =  $40; //*
  chanflag_autolimit      =  $80; //*
  chanflag_forcekey       = $100; //*
  chanflag_forcelimit     = $200; //*


var
  chanflagtable_suspended,
  chanflagtable_bitch,
  chanflagtable_protectops,
  chanflagtable_forcetopic,
  chanflagtable_welcomemessage,
  chanflagtable_forceinvite,
  chanflagtable_autolimit,
  chanflagtable_forcekey,
  chanflagtable_forcelimit : integer;


const
  maxchanflagtable=8;

  chanflagtable:array[0..maxchanflagtable] of tchanflagtable=(
  (c:'s';flag:chanflag_suspended;num:@chanflagtable_suspended),
  (c:'b';flag:chanflag_bitch;num:@chanflagtable_bitch),
  (c:'p';flag:chanflag_protectops;num:@chanflagtable_protectops),
  (c:'f';flag:chanflag_forcetopic;num:@chanflagtable_forcetopic),
  (c:'w';flag:chanflag_welcomemessage;num:@chanflagtable_welcomemessage),
  (c:'i';flag:chanflag_forceinvite;num:@chanflagtable_forceinvite),
  (c:'c';flag:chanflag_autolimit;num:@chanflagtable_autolimit),
  (c:'k';flag:chanflag_forcekey;num:@chanflagtable_forcekey),
  (c:'l';flag:chanflag_forcelimit;num:@chanflagtable_forcelimit)
  );

function makeflagstr(const v;max,flags:integer) :string;

implementation

function makeflagstr(const v;max,flags:integer) :string;
var
  flagtable:achanflagtable absolute v;
  counter : integer;
begin
  result := '';
  for counter := 0 to max do begin
    if (flagtable[counter].flag and flags) <> 0 then begin
      result := result + flagtable[counter].c;
    end;
  end;
end;
var
  a:integer;
initialization
  for a := 0 to maxchanflagtable do if chanflagtable[a].num <> nil then
  chanflagtable[a].num^ := a;
end.
