unit unixsignals;

interface

procedure init;

implementation
uses
  {$ifdef VER1_0}
    linux,
  {$else}
    baseunix,unix,
  {$endif}
  lsignal,bconfig,bservicemngr,bservunit,bconsts,pgdebugout;
{$include unixstuff.inc}
var
  locallsignal : tlsignal;
type
  tsc=class
    procedure onsignal(sender:tobject;signal:integer);
  end;
var
  sc : tsc;

procedure init;
begin
  starthandlesignal(sigterm);
  starthandlesignal(sighup);
  locallsignal := tlsignal.create(nil);
  locallsignal.onsignal := sc.onsignal;

end;

procedure tsc.onsignal(sender:tobject;signal:integer);
var
  A : integer;
begin
  case signal of
    sigterm : begin
      debugout('sigterm received');
      globalshutdown;
    end;
    {sighup : begin
      debugout('sighup received');

      bconfig.init;

      for a := 0 to maxserviceunit do begin
        if serviceunitarray[a] <> nil then begin
          if @serviceunitarray[a].onrehash <> nil then begin
            serviceunitarray[a].onrehash(serviceunitarray[a].tag);
          end;
        end;
      end;
    end;}
  end;
end;
end.
