unit objbot;

interface
  //uses
  //  sysutils,
  //  bservicemngr;
  uses
    sysutils , bservicemngr , pgtypes   , buser , bparse , bstuff , bcmds ,
    bchannel , bservunit    , blinklist ;

  type
    tobjbot=class
    public
      up : boolean;
      srvunit : tserviceunit;
      constructor create;
      destructor destroy;override;
      procedure setupsrvunit;virtual;
    end;


implementation

procedure onstartup(tag:taddrint);
begin
  with tobjbot(tag) do begin
    if up then exit;
    up := true;
    //mybot := addbot(srvunit,nick,userid,host,realname,0);
    //prefix := sendprefixstr(mybot);
  end;
end;

procedure onshutdown(tag:taddrint);
begin
  with tobjbot(tag) do begin
    if not up then exit;
    up := false;

    //bot_quit(mybot,shutdownreason);
    //mybot := nil;
  end;
end;



procedure tobjbot.setupsrvunit;
begin
  if not assigned(srvunit) then srvunit := createserviceunit;
  //srvunit.name := 'invkickbot';
  srvunit.onstartup := onstartup;
  //srvunit.onparse   := onparse;
  //srvunit.oninvite  := oninvite;
  //srvunit.onleavechannel := onleavechannel;
  srvunit.onshutdown := onshutdown;
  //srvunit.onprivmsg := onprivmsg;
  //srvunit.ontimer := ontimer;
  //srvunit.onsave := onsave;
  //srvunit.onaccount := onaccount;
  //srvunit.ondestroyuser := ondestroyuser;
  //srvunit.onrehash := onrehash;
  srvunit.tag := taddrint(self);

end;
constructor tobjbot.create;
begin
  inherited create;

  setupsrvunit;
  if not registerserviceunit(srvunit) then begin
    raise exception.create('unable to register service unit');
  end;

end;

destructor tobjbot.destroy;

begin
  inherited destroy;
end;



end.
